$(function() {

    rdt('track', 'ViewContent');
    fbq('track', 'ViewContent');
    var itemId = $(".itemDetail").data('item-id');
    var index1 = $(".itemDetail").data('index-1');
    var index2 = $(".itemDetail").data('index-2');

    $('.editButton').click(function() {
        showReportItemModal(itemId);
    });    

    function hookupArrows(comments) {
        comments.find('.arrows i').click(function() {
            var $this = $(this);
            var isLoggedIn = $("body").data('logged-in');
            if (isLoggedIn) {
                var ratingId = $(this).parents('.comment').data('rating-id');
                var vote = $(this).hasClass('fa-caret-up') ? 1 : -1;
                $.ajax({
                    url: '/rating/' + ratingId + '/votes',
                    type: 'post',
                    data: {
                        vote: vote
                    }
                })
                .then(function(voteSum) {
                    $this.siblings('span').html(voteSum);
                });
            } else {
                showLogin()
                .then(function(loggedIn) {
                    if (loggedIn) {
                        $this.click();
                    }
                });
            }
        });
        
    }

    function hookupAddComment(topicRowContainer) {
        
        topicRowContainer.find(".addComment").each(function() {
            if (!$(this).data('add-comment-initialized')) {
                $(this).data('add-comment-initialized', true);
                $(this).click(function() {
                    let index1 = $(this).parents('[data-index1]').data('index1');
                    let index2 = $(this).parents('[data-index2]').data('index2');
                    var ratingId = $(this).parents('[data-rating-id]').data('rating-id');
                    var isLoggedIn = $("body").data('logged-in');
                    var userId = null;
                    if ($(this).parents("[data-user-id]").length > 0) {
                        userId = $(this).parents("[data-user-id]").data("user-id");
                    }
                    if (isLoggedIn) {
                        var $this = $(this);
                        var $topicRowContainer = $this.parents('.topicRowContainer');
                        var topicId = $topicRowContainer.data('topic-id');
                        var commentsShown = $topicRowContainer.find('.viewComments').length == 0;
        
                        var options = {
                            topicId: topicId,
                            itemId: itemId,
                            index1: index1,
                            index2: index2,
                            responseType: 'item',
                            expandComments: commentsShown,
                            displayIndex1: $('.itemDetail').data('index-1'),
                            displayIndex2: $('.itemDetail').data('index-2'),
                            userId: userId
                        };
        
                        if (ratingId) {
                            options.ratingId = ratingId;
                        }
        
                        $.ajax({
                            url: '/rating',
                            data: options
                        }).then(function(result) {
                            $("#ratingModal").html(result);
                            $("#ratingModal .closeModal").click(function() {
                                $("#ratingModal").modal('hide');
                            });
                            $("#ratingModal").ajaxForm(function(result) {
                                topicRowContainer.html(result);
                                hookupTopicRowContainer(topicRowContainer);
                                $("#ratingModal").modal('hide');
                            });
                            $("#ratingModal").modal('show');
                        });
                    } else {
                        showLogin()
                        .then(function(loggedIn) {
                            if (loggedIn) {
                                topicRowContainer.find('.addComment').click();
                            }
                        });
                    }
                    
                });
            }
        });
        
    }
    
    

    function hookupTopicRowContainer(topicRowContainer) {

        topicRowContainer.find('.viewComments').click(function() {
            var $topicRowContainer = $(this).parents('.topicRowContainer');
            var $topicRow = $(this).parents('.topicRow');
            var topicId = $topicRowContainer.data('topic-id');

            var loaded = $topicRowContainer.data('loaded');
            var animating = $topicRowContainer.data('animating');
            
            if (animating) {
                return;
            }

            $topicRowContainer.find('.viewComments').remove();
            $topicRowContainer.find('.verticalBar').remove();
            // $topicRowContainer.find('.hideComments').show();

            $topicRowContainer.data('animating', true);
            if (loaded) {
                $topicRowContainer.find('.commentsContainer').slideDown(400, function() {
                    $topicRowContainer.data('animating', false);
                });
            } else {
                $topicRowContainer.data("loaded", true);
                var exceptId = null;
                var $topComment = $topicRowContainer.find('.comment');
                if ($topComment.length > 0) {
                    exceptId = $topComment.data('rating-id');
                }
                $.ajax({
                    url: '/topics/' + topicId + '/media/' + itemId + '/comments',
                    data: {
                        except: exceptId,
                        index1: index1,
                        index2: index2
                    }
                })
                .then(function(result) {
                    var newComments = $(result);
                    $topicRowContainer.find('.comments').show().append(newComments);
                    hookupArrows(newComments);
                    hookupAddComment($topicRowContainer);
                    $topicRowContainer.find('.commentsContainer').slideDown(400, function() {
                        $topicRowContainer.data('animating', false);
                    });
                });    
            }
        });

        topicRowContainer.find('.hideComments').click(function() {
            var $topicRowContainer = $(this).parents('.topicRowContainer');

            var animating = $topicRowContainer.data('animating');

            if (animating) {
                return;
            }

            // $topicRowContainer.find('.viewComments').show();
            // $topicRowContainer.find('.hideComments').hide();

            $topicRowContainer.data('animating', true);
            $topicRowContainer.find('.commentsContainer').slideUp(400, function() {
                $topicRowContainer.data('animating', false);
            });
            
        });

        hookupAddComment(topicRowContainer);

        topicRowContainer.find(".yes, .no").click(function() {
            var isLoggedIn = $("body").data('logged-in');
            var $this = $(this);
            var $topicRowContainer = $this.parents('.topicRowContainer');
            var topicId = $topicRowContainer.data('topic-id');
            if (isLoggedIn) {
                var choice = $this.hasClass('yes') ? 'yes' : 'no';
                $.ajax({
                    url: '/rating',
                    type: 'post',
                    data: {
                        topicId: topicId,
                        itemId: itemId,
                        index1: index1,
                        index2: index2,
                        choice: choice
                    }
                })
                .then(function(counts) {
                    $topicRowContainer.find('.yes .count').html(counts.yesSum);
                    $topicRowContainer.find('.no .count').html(counts.noSum);
                    if (counts.yesSum > counts.noSum) {
                        $topicRowContainer.find('.yes').addClass('winner');
                        $topicRowContainer.find('.no').removeClass('winner');
                    } else if (counts.noSum > counts.yesSum) {
                        $topicRowContainer.find('.yes').removeClass('winner');
                        $topicRowContainer.find('.no').addClass('winner');
                    }
                });
            } else {
                showLogin()
                .then(function(loggedIn) {
                    if (loggedIn) {
                        $this.click();
                    }
                });
            }
        });

        hookupArrows(topicRowContainer.find('.comments'));

        topicRowContainer.find('.fa-thumbtack').click(function() {
            var $this = $(this);
            var isLoggedIn = $("body").data('logged-in');
            if (isLoggedIn) {
                var $topicRowContainer = $this.parents('.topicRowContainer');
                var topicId = $topicRowContainer.data('topic-id');
                var url = '/favorites/';
                if ($this.hasClass('favorite')) {
                    url += 'remove';
                } else {
                    url += 'add';
                }
                url += '?topicId=' + topicId;
                $.ajax(url)
                .then(function() {
                    location.reload();
                });
            } else {
                showLogin()
                .then(function(loggedIn) {
                    if (loggedIn) {
                        $this.click();
                    }
                });   
            }
        });

    }

    $(".topicRowContainer").each(function() {
        hookupTopicRowContainer($(this));
    });


    $("#index1, #index2").change(function() {
        index1 = $("#index1").val();
        index2 = $("#index2").val();
        location.href = '/media/' + itemId + "?index1=" + index1 + (index2 ? ("&index2=" + index2) : '');
    });
});